# KMeans Example using RAPIDS cuML in pai4sk

This is a sample code to show how kmeans from cuML in pai4sk can be used.
The sample code performs kmeans clustering through cuML in pai4sk and through
scikit-learn and compares the results.

# How to run the example
If cuml is not already installed, run `conda install cuml` in a python3.6 conda
environment. Similarly, if pandas and scikit-learn are not already installed in
the conda environment, run `conda install pandas scikit-learn`. Then run the
example as below and all GPUs will be used.

```
python example-kmeans.py --nrows 5000 --nclusters 2
```

The above command first generates random dataset with 2 clusters containing 5000 samples
and 3 features. Then performs KMeans clustering through cuML in pai4sk and through
scikit-learn and compares the results.
Default value for --nrows is 1000 and the default value for --nclusters is 2.

&copy; Copyright IBM Corporation 2019
